| Version: 3.3.1

Public Types | Public Member Functions | Protected Member Functions | List of all members
wxRichTextStyleListBox Class Reference
Class List by Category » Rich Text

`#include <wx/richtext/richtextstyles.h>`

Inheritance diagram for wxRichTextStyleListBox:
[legend]

## Detailed Description

This is a listbox that can display the styles in a wxRichTextStyleSheet, and apply the selection to an associated wxRichTextCtrl.

See `samples/richtext` for an example of how to use it.

##

Library: wxRichText
Category: Rich Text

See also
  wxRichTextStyleComboCtrl, wxRichTextCtrl Overview

## Public Types
enum | wxRichTextStyleType { wxRICHTEXT_STYLE_ALL , wxRICHTEXT_STYLE_PARAGRAPH , wxRICHTEXT_STYLE_CHARACTER , wxRICHTEXT_STYLE_LIST , wxRICHTEXT_STYLE_BOX }
| Which type of style definition is currently showing? More...

## Public Member Functions
| wxRichTextStyleListBox (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0)
| Constructor. More...
| wxRichTextStyleListBox ()
virtual | ~wxRichTextStyleListBox ()
| Destructor. More...
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0)
| Creates the window. More...
void | ApplyStyle (int i)
| Applies the ith style to the associated rich text control. More...
int | ConvertTenthsMMToPixels (wxDC &dc, int units) const
| Converts units in tenths of a millimetre to device units. More...
wxString | CreateHTML (wxRichTextStyleDefinition *def) const
| Creates a suitable HTML fragment for a definition. More...
bool | GetApplyOnSelection () const
| If the return value is true, clicking on a style name in the list will immediately apply the style to the associated rich text control. More...
wxRichTextCtrl * | GetRichTextCtrl () const
| Returns the wxRichTextCtrl associated with this listbox. More...
wxRichTextStyleDefinition * | GetStyle (size_t i) const
| Gets a style for a listbox index. More...
wxRichTextStyleSheet * | GetStyleSheet () const
| Returns the style sheet associated with this listbox. More...
wxRichTextStyleListBox::wxRichTextStyleType | GetStyleType () const
| Returns the type of style to show in the list box. More...
void | OnLeftDown (wxMouseEvent &event)
| Implements left click behaviour, applying the clicked style to the wxRichTextCtrl. More...
void | SetApplyOnSelection (bool applyOnSelection)
| If applyOnSelection is true, clicking on a style name in the list will immediately apply the style to the associated rich text control. More...
void | SetRichTextCtrl (wxRichTextCtrl *ctrl)
| Associates the listbox with a wxRichTextCtrl. More...
void | SetStyleSheet (wxRichTextStyleSheet *styleSheet)
| Associates the control with a style sheet. More...
void | SetStyleType (wxRichTextStyleListBox::wxRichTextStyleType styleType)
| Sets the style type to display. More...
void | UpdateStyles ()
| Updates the list from the associated style sheet. More...
Public Member Functions inherited from wxHtmlListBox
| wxHtmlListBox (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxHtmlListBoxNameStr)
| Normal constructor which calls Create() internally. More...
| wxHtmlListBox ()
| Default constructor, you must call Create() later. More...
virtual | ~wxHtmlListBox ()
| Destructor cleans up whatever resources we use. More...
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxHtmlListBoxNameStr)
| Creates the control and optionally sets the initial number of items in it (it may also be set or changed later with wxVListBox::SetItemCount). More...
wxFileSystem & | GetFileSystem () const
| Returns the wxFileSystem used by the HTML parser of this object. More...
const wxFileSystem & | GetFileSystem () const
| Returns the wxFileSystem used by the HTML parser of this object. More...
Public Member Functions inherited from wxVListBox
| wxVListBox ()
| Default constructor, you must call Create() later. More...
| wxVListBox (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxVListBoxNameStr)
| Normal constructor which calls Create() internally. More...
virtual | ~wxVListBox ()
| Destructor. More...
void | Clear ()
| Deletes all items from the control. More...
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxVListBoxNameStr)
| Creates the control. More...
bool | DeselectAll ()
| Deselects all the items in the listbox. More...
int | GetFirstSelected (unsigned long &cookie) const
| Returns the index of the first selected item in the listbox or `wxNOT_FOUND` if no items are currently selected. More...
size_t | GetItemCount () const
| Get the number of items in the control. More...
wxPoint | GetMargins () const
| Returns the margins used by the control. More...
wxRect | GetItemRect (size_t item) const
| Returns the rectangle occupied by this item in physical coordinates. More...
int | GetNextSelected (unsigned long &cookie) const
| Returns the index of the next selected item or `wxNOT_FOUND` if there are no more. More...
size_t | GetSelectedCount () const
| Returns the number of the items currently selected. More...
int | GetSelection () const
| Get the currently selected item or `wxNOT_FOUND` if there is no selection. More...
const wxColour & | GetSelectionBackground () const
| Returns the background colour used for the selected cells. More...
bool | HasMultipleSelection () const
| Returns true if the listbox was created with `wxLB_MULTIPLE` style and so supports multiple selection or false if it is a single selection listbox. More...
bool | IsCurrent (size_t item) const
| Returns true if this item is the current one, false otherwise. More...
int | GetCurrent () const
| Get the current item or `wxNOT_FOUND` if there is no current item. More...
void | SetCurrent (int current)
| Set the specified item as the current item, if it is wxNOT_FOUND the current item is unset. More...
bool | IsSelected (size_t item) const
| Returns true if this item is selected, false otherwise. More...
bool | Select (size_t item, bool select=true)
| Selects or deselects the specified item which must be valid (i.e. not equal to `wxNOT_FOUND`). More...
bool | SelectAll ()
| Selects all the items in the listbox. More...
bool | SelectRange (size_t from, size_t to)
| Selects all items in the specified range which may be given in any order. More...
virtual void | SetItemCount (size_t count)
| Set the number of items to be shown in the control. More...
void | SetSelection (int selection)
| Set the selection to the specified item, if it is -1 the selection is unset. More...
void | SetSelectionBackground (const wxColour &col)
| Sets the colour to be used for the selected cells background. More...
void | Toggle (size_t item)
| Toggles the state of the specified item, i.e. selects it if it was unselected and deselects it if it was selected. More...
void | SetMargins (const wxPoint &pt)
| Set the margins: horizontal margin is the distance between the window border and the item contents while vertical margin is half of the distance between items. More...
void | SetMargins (wxCoord x, wxCoord y)
| Set the margins: horizontal margin is the distance between the window border and the item contents while vertical margin is half of the distance between items. More...
Public Member Functions inherited from wxVScrolled< T >
| wxVScrolled ()
| Default constructor, you must call Create() later. More...
| wxVScrolled (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| This is the normal constructor, no need to call Create() after using this constructor. More...
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created. More...
Public Member Functions inherited from wxVarVScrollHelper
| wxVarVScrollHelper (wxWindow *winToScroll)
| Constructor taking the target window to be scrolled by this helper class. More...
size_t | GetRowCount () const
| Returns the number of rows the target window contains. More...
size_t | GetVisibleRowsBegin () const
| Returns the index of the first visible row based on the scroll position. More...
size_t | GetVisibleRowsEnd () const
| Returns the index of the last visible row based on the scroll position. More...
bool | IsRowVisible (size_t row) const
| Returns true if the given row is currently visible (even if only partially visible) or false otherwise. More...
virtual void | RefreshRow (size_t row)
| Triggers a refresh for just the given row's area of the window if it's visible. More...
virtual void | RefreshRows (size_t from, size_t to)
| Triggers a refresh for the area between the specified range of rows given (inclusively). More...
virtual bool | ScrollRowPages (int pages)
| Scroll by the specified number of pages which may be positive (to scroll down) or negative (to scroll up). More...
virtual bool | ScrollRows (int rows)
| Scroll by the specified number of rows which may be positive (to scroll down) or negative (to scroll up). More...
bool | ScrollToRow (size_t row)
| Scroll to the specified row. More...
void | SetRowCount (size_t rowCount)
| Set the number of rows the window contains. More...
Public Member Functions inherited from wxVarScrollHelperBase
| wxVarScrollHelperBase (wxWindow *winToScroll)
| Constructor taking the target window to be scrolled by this helper class. More...
virtual | ~wxVarScrollHelperBase ()
| Virtual destructor for detaching scroll event handlers attached with this helper class. More...
int | CalcScrolledPosition (int coord) const
| Translates the logical coordinate given to the current device coordinate. More...
int | CalcUnscrolledPosition (int coord) const
| Translates the device coordinate given to the corresponding logical coordinate. More...
void | EnablePhysicalScrolling (bool scrolling=true)
| With physical scrolling on (when this is true), the device origin is changed properly when a wxPaintDC is prepared, children are actually moved and laid out properly, and the contents of the window (pixels) are actually moved. More...
virtual int | GetNonOrientationTargetSize () const =0
| This function needs to be overridden in the in the derived class to return the window size with respect to the opposing orientation. More...
virtual wxOrientation | GetOrientation () const =0
| This function need to be overridden to return the orientation that this helper is working with, either `wxHORIZONTAL` or `wxVERTICAL`. More...
virtual int | GetOrientationTargetSize () const =0
| This function needs to be overridden in the in the derived class to return the window size with respect to the orientation this helper is working with. More...
virtual wxWindow * | GetTargetWindow () const
| This function will return the target window this helper class is currently scrolling. More...
size_t | GetVisibleBegin () const
| Returns the index of the first visible unit based on the scroll position. More...
size_t | GetVisibleEnd () const
| Returns the index of the last visible unit based on the scroll position. More...
bool | IsVisible (size_t unit) const
| Returns true if the given scroll unit is currently visible (even if only partially visible) or false otherwise. More...
virtual void | RefreshAll ()
| Recalculate all parameters and repaint all units. More...
virtual void | SetTargetWindow (wxWindow *target)
| Normally the window will scroll itself, but in some rare occasions you might want it to scroll (part of) another window (e.g. More...
virtual void | UpdateScrollbar ()
| Update the thumb size shown by the scrollbar. More...
int | VirtualHitTest (wxCoord coord) const
| Returns the virtual scroll unit under the device unit given accounting for scroll position or `wxNOT_FOUND` if none (i.e. More...

## Protected Member Functions
virtual wxString | OnGetItem (size_t n) const
| Returns the HTML for this item. More...
Protected Member Functions inherited from wxHtmlListBox
virtual void | OnLinkClicked (size_t n, const wxHtmlLinkInfo &link)
| Called when the user clicks on hypertext link. More...
virtual wxColour | GetSelectedTextBgColour (const wxColour &colBg) const
| This virtual function may be overridden to change the appearance of the background of the selected cells in the same way as GetSelectedTextColour(). More...
virtual wxColour | GetSelectedTextColour (const wxColour &colFg) const
| This virtual function may be overridden to customize the appearance of the selected cells. More...
virtual wxString | OnGetItemMarkup (size_t n) const
| This function may be overridden to decorate HTML returned by OnGetItem(). More...
Protected Member Functions inherited from wxVListBox
virtual void | OnDrawItem (wxDC &dc, const wxRect &rect, size_t n) const =0
| The derived class must implement this function to actually draw the item with the given index on the provided DC. More...
virtual void | OnDrawBackground (wxDC &dc, const wxRect &rect, size_t n) const
| This method is used to draw the item's background and, maybe, a border around it. More...
virtual void | OnDrawSeparator (wxDC &dc, wxRect &rect, size_t n) const
| This method may be used to draw separators between the lines. More...
virtual wxCoord | OnMeasureItem (size_t n) const =0
| The derived class must implement this method to return the height of the specified item (in pixels). More...
Protected Member Functions inherited from wxVarVScrollHelper
virtual void | OnGetRowsHeightHint (size_t rowMin, size_t rowMax) const
| This function doesn't have to be overridden but it may be useful to do so if calculating the rows' sizes is a relatively expensive operation as it gives your code a chance to calculate several of them at once and cache the result if necessary. More...
virtual wxCoord | EstimateTotalHeight () const
| This class forwards calls from EstimateTotalSize() to this function so derived classes can override either just the height or the width estimation, or just estimate both differently if desired in any wxHVScrolledWindow derived class. More...
virtual wxCoord | OnGetRowHeight (size_t row) const =0
| This function must be overridden in the derived class, and should return the height of the given row in pixels. More...
Protected Member Functions inherited from wxVarScrollHelperBase
virtual void | OnGetUnitsSizeHint (size_t unitMin, size_t unitMax) const
| This function doesn't have to be overridden but it may be useful to do so if calculating the units' sizes is a relatively expensive operation as it gives your code a chance to calculate several of them at once and cache the result if necessary. More...
virtual wxCoord | EstimateTotalSize () const
| When the number of scroll units change, we try to estimate the total size of all units when the full window size is needed (i.e. More...
virtual wxCoord | OnGetUnitSize (size_t unit) const =0
| This function must be overridden in the derived class, and should return the size of the given unit in pixels. More...

## Member Enumeration Documentation

## ◆ wxRichTextStyleType

enum wxRichTextStyleListBox::wxRichTextStyleType

Which type of style definition is currently showing?

Enumerator
wxRICHTEXT_STYLE_ALL |
wxRICHTEXT_STYLE_PARAGRAPH |
wxRICHTEXT_STYLE_CHARACTER |
wxRICHTEXT_STYLE_LIST |
wxRICHTEXT_STYLE_BOX |

## Constructor & Destructor Documentation

## ◆ wxRichTextStyleListBox() [1/2]

wxRichTextStyleListBox::wxRichTextStyleListBox | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`
| ) |  |

Constructor.

## ◆ wxRichTextStyleListBox() [2/2]

wxRichTextStyleListBox::wxRichTextStyleListBox | ( |  | ) |

## ◆ ~wxRichTextStyleListBox()

virtual wxRichTextStyleListBox::~wxRichTextStyleListBox | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ ApplyStyle()

void wxRichTextStyleListBox::ApplyStyle | ( | int | i | ) |

Applies the ith style to the associated rich text control.

## ◆ ConvertTenthsMMToPixels()

int wxRichTextStyleListBox::ConvertTenthsMMToPixels | ( | wxDC & | dc,
|  | int | units
| ) |  | const

Converts units in tenths of a millimetre to device units.

## ◆ Create()

bool wxRichTextStyleListBox::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`
| ) |  |

Creates the window.

## ◆ CreateHTML()

wxString wxRichTextStyleListBox::CreateHTML | ( | wxRichTextStyleDefinition * | def | ) | const

Creates a suitable HTML fragment for a definition.

## ◆ GetApplyOnSelection()

bool wxRichTextStyleListBox::GetApplyOnSelection | ( |  | ) | const

If the return value is true, clicking on a style name in the list will immediately apply the style to the associated rich text control.

## ◆ GetRichTextCtrl()

wxRichTextCtrl* wxRichTextStyleListBox::GetRichTextCtrl | ( |  | ) | const

Returns the wxRichTextCtrl associated with this listbox.

## ◆ GetStyle()

wxRichTextStyleDefinition* wxRichTextStyleListBox::GetStyle | ( | size_t | i | ) | const

Gets a style for a listbox index.

## ◆ GetStyleSheet()

wxRichTextStyleSheet* wxRichTextStyleListBox::GetStyleSheet | ( |  | ) | const

Returns the style sheet associated with this listbox.

## ◆ GetStyleType()

wxRichTextStyleListBox::wxRichTextStyleType wxRichTextStyleListBox::GetStyleType | ( |  | ) | const

Returns the type of style to show in the list box.

## ◆ OnGetItem()

virtual wxString wxRichTextStyleListBox::OnGetItem | ( | size_t | n | ) | const
| protected virtual

Returns the HTML for this item.

Implements wxHtmlListBox.

## ◆ OnLeftDown()

void wxRichTextStyleListBox::OnLeftDown | ( | wxMouseEvent & | event | ) |

Implements left click behaviour, applying the clicked style to the wxRichTextCtrl.

## ◆ SetApplyOnSelection()

void wxRichTextStyleListBox::SetApplyOnSelection | ( | bool | applyOnSelection | ) |

If applyOnSelection is true, clicking on a style name in the list will immediately apply the style to the associated rich text control.

## ◆ SetRichTextCtrl()

void wxRichTextStyleListBox::SetRichTextCtrl | ( | wxRichTextCtrl * | ctrl | ) |

Associates the listbox with a wxRichTextCtrl.

## ◆ SetStyleSheet()

void wxRichTextStyleListBox::SetStyleSheet | ( | wxRichTextStyleSheet * | styleSheet | ) |

Associates the control with a style sheet.

## ◆ SetStyleType()

void wxRichTextStyleListBox::SetStyleType | ( | wxRichTextStyleListBox::wxRichTextStyleType | styleType | ) |

Sets the style type to display.

One of

- wxRichTextStyleListBox::wxRICHTEXT_STYLE_ALL,
- wxRichTextStyleListBox::wxRICHTEXT_STYLE_PARAGRAPH,
- wxRichTextStyleListBox::wxRICHTEXT_STYLE_CHARACTER
- wxRichTextStyleListBox::wxRICHTEXT_STYLE_LIST.

## ◆ UpdateStyles()

void wxRichTextStyleListBox::UpdateStyles | ( |  | ) |

Updates the list from the associated style sheet.